#ifndef OAdapterUtilsH
#define OAdapterUtilsH

#include <map.h>
#include <stlport\memory>
#include <system.hpp>

namespace OAdapterUtils
{
    ////////////////////////////////////////////////////////////////////////////
    //
    //      Variant,  
    //   .
    //
    class PACKAGE CFields: private map<AnsiString, Variant>
    {
    public:
        const Variant operator [](const AnsiString Index);
              bool    Insert(const AnsiString Index, const Variant Value);
              bool    Delete(const AnsiString Index);
    };

    typedef auto_ptr<CFields> PFields;

    class PACKAGE CResFields: private pair<bool, PFields>
    {
    private:
    public:
        CResFields();
        CResFields(bool Executed);
        const Variant operator [] (const AnsiString Index);
              bool    Insert(const AnsiString Index, const Variant Value);
              bool    Delete(const AnsiString Index);
        __property bool Executed = {read = first, write = first};
    };

    typedef auto_ptr<CResFields> PResFields;

    ////////////////////////////////////////////////////////////////////////////
    //
    //       CFields, 
    //    .  - ,   
    //    CFields  .  
    //   .
    //
    class PACKAGE CTable: private map<int, CFields>
    {
    private:
        int UniqueIndex;
    public:
        CTable();
        void Insert(CFields& const Fields);
        //CFields& const Insert();
        bool Delete(const int Index);
        CFields& operator[](int Index);
        __property int Count = {read = size};
    };

    ////////////////////////////////////////////////////////////////////////////
    //
    // -  "".
    //
    typedef auto_ptr<CTable> PTable;

    ////////////////////////////////////////////////////////////////////////////
    //
    //   .  -    bool   
    // . bool ,   .  ,  
    //  .
    //
    class PACKAGE CResTable: private pair<bool, PTable>
    {
    private:
        //CTable* GetTable();
        bool GetValid();
        int GetCount();
    public:
        CResTable();
        CResTable(bool Executed);
        CFields& operator[](int Index);
        void Insert(CFields& const Fields);
        //CFields& const Insert();
        bool Delete(const int Index);
        __property bool Executed = {read = first, write = first};
        __property bool Valid = {read = GetValid};
        __property bool Count = {read = GetCount};
        //__property CTable* Table = {read = GetTable};
    };

    ////////////////////////////////////////////////////////////////////////////
    //
    // -   ,   -   
    //     () 
    //
    typedef auto_ptr<CResTable> PResTable;
}

#endif
